import os
import shutil
import tempfile
import unittest
from paste.deploy import loadapp
from webob import Request
from waeup.cas.server import CASServer


class CASServerTests(unittest.TestCase):

    def setUp(self):
        self.workdir = tempfile.mkdtemp()
        self.paste_conf1 = os.path.join(
            os.path.dirname(__file__), 'sample1.ini')

    def tearDown(self):
        shutil.rmtree(self.workdir)

    def test_paste_deploy_loader(self):
        # we can load the CAS server via paste.deploy plugin
        app = loadapp('config:%s' % self.paste_conf1)
        assert isinstance(app, CASServer)

    def test_paste_deploy_options(self):
        # we can set CAS server-related options via paste.deploy config
        app = loadapp('config:%s' % self.paste_conf1)
        assert isinstance(app, CASServer)

    def test_call_root(self):
        app = CASServer()
        req = Request.blank('http://localhost/')
        resp = app(req)
        assert resp.status == '200 OK'
